Index: XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90	(revision 664)
+++ XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90	(revision 666)
@@ -13,8 +13,8 @@
   SUBROUTINE xios(set_domaingroup_attr)  &
     ( domaingroup_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-    , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -31,5 +31,4 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: data_j_index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: data_jbegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: data_n_index
       INTEGER  , OPTIONAL, INTENT(IN) :: data_ni
       INTEGER  , OPTIONAL, INTENT(IN) :: data_nj
@@ -62,8 +61,8 @@
       CALL xios(set_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-      , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(set_domaingroup_attr)
@@ -71,8 +70,8 @@
   SUBROUTINE xios(set_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-    , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -88,5 +87,4 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: data_j_index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: data_jbegin
-      INTEGER  , OPTIONAL, INTENT(IN) :: data_n_index
       INTEGER  , OPTIONAL, INTENT(IN) :: data_ni
       INTEGER  , OPTIONAL, INTENT(IN) :: data_nj
@@ -118,8 +116,8 @@
       CALL xios(set_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-      , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(set_domaingroup_attr_hdl)
@@ -127,8 +125,8 @@
   SUBROUTINE xios(set_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lon_1d_, bounds_lon_2d_, data_dim_  &
-    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_n_index_, data_ni_, data_nj_  &
-    , domain_group_ref_, domain_ref_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_  &
-    , latvalue_2d_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_  &
-    , nj_, nj_glo_, nvertex_, standard_name_, type_ )
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_group_ref_  &
+    , domain_ref_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
+    , long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_  &
+    , nvertex_, standard_name_, type_ )
 
     IMPLICIT NONE
@@ -144,5 +142,4 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: data_j_index_(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: data_jbegin_
-      INTEGER  , OPTIONAL, INTENT(IN) :: data_n_index_
       INTEGER  , OPTIONAL, INTENT(IN) :: data_ni_
       INTEGER  , OPTIONAL, INTENT(IN) :: data_nj_
@@ -212,8 +209,4 @@
       ENDIF
 
-      IF (PRESENT(data_n_index_)) THEN
-        CALL cxios_set_domaingroup_data_n_index(domaingroup_hdl%daddr, data_n_index_)
-      ENDIF
-
       IF (PRESENT(data_ni_)) THEN
         CALL cxios_set_domaingroup_data_ni(domaingroup_hdl%daddr, data_ni_)
@@ -320,8 +313,8 @@
   SUBROUTINE xios(get_domaingroup_attr)  &
     ( domaingroup_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-    , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -338,5 +331,4 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_j_index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_jbegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: data_n_index
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_ni
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_nj
@@ -369,8 +361,8 @@
       CALL xios(get_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-      , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(get_domaingroup_attr)
@@ -378,8 +370,8 @@
   SUBROUTINE xios(get_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-    , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -395,5 +387,4 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_j_index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_jbegin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: data_n_index
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_ni
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_nj
@@ -425,8 +416,8 @@
       CALL xios(get_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-      , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(get_domaingroup_attr_hdl)
@@ -434,8 +425,8 @@
   SUBROUTINE xios(get_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lon_1d_, bounds_lon_2d_, data_dim_  &
-    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_n_index_, data_ni_, data_nj_  &
-    , domain_group_ref_, domain_ref_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_  &
-    , latvalue_2d_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_  &
-    , nj_, nj_glo_, nvertex_, standard_name_, type_ )
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_group_ref_  &
+    , domain_ref_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
+    , long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_  &
+    , nvertex_, standard_name_, type_ )
 
     IMPLICIT NONE
@@ -451,5 +442,4 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_j_index_(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_jbegin_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: data_n_index_
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_ni_
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_nj_
@@ -519,8 +509,4 @@
       ENDIF
 
-      IF (PRESENT(data_n_index_)) THEN
-        CALL cxios_get_domaingroup_data_n_index(domaingroup_hdl%daddr, data_n_index_)
-      ENDIF
-
       IF (PRESENT(data_ni_)) THEN
         CALL cxios_get_domaingroup_data_ni(domaingroup_hdl%daddr, data_ni_)
@@ -627,8 +613,8 @@
   SUBROUTINE xios(is_defined_domaingroup_attr)  &
     ( domaingroup_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-    , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -655,6 +641,4 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_jbegin
       LOGICAL(KIND=C_BOOL) :: data_jbegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: data_n_index
-      LOGICAL(KIND=C_BOOL) :: data_n_index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_ni
       LOGICAL(KIND=C_BOOL) :: data_ni_tmp
@@ -709,8 +693,8 @@
       CALL xios(is_defined_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-      , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(is_defined_domaingroup_attr)
@@ -718,8 +702,8 @@
   SUBROUTINE xios(is_defined_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-    , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -745,6 +729,4 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_jbegin
       LOGICAL(KIND=C_BOOL) :: data_jbegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: data_n_index
-      LOGICAL(KIND=C_BOOL) :: data_n_index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_ni
       LOGICAL(KIND=C_BOOL) :: data_ni_tmp
@@ -798,8 +780,8 @@
       CALL xios(is_defined_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref  &
-      , domain_ref, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(is_defined_domaingroup_attr_hdl)
@@ -807,8 +789,8 @@
   SUBROUTINE xios(is_defined_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lon_1d_, bounds_lon_2d_, data_dim_  &
-    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_n_index_, data_ni_, data_nj_  &
-    , domain_group_ref_, domain_ref_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_  &
-    , latvalue_2d_, long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_  &
-    , nj_, nj_glo_, nvertex_, standard_name_, type_ )
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_group_ref_  &
+    , domain_ref_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
+    , long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_  &
+    , nvertex_, standard_name_, type_ )
 
     IMPLICIT NONE
@@ -834,6 +816,4 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_jbegin_
       LOGICAL(KIND=C_BOOL) :: data_jbegin__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: data_n_index_
-      LOGICAL(KIND=C_BOOL) :: data_n_index__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_ni_
       LOGICAL(KIND=C_BOOL) :: data_ni__tmp
@@ -935,9 +915,4 @@
       ENDIF
 
-      IF (PRESENT(data_n_index_)) THEN
-        data_n_index__tmp = cxios_is_defined_domaingroup_data_n_index(domaingroup_hdl%daddr)
-        data_n_index_ = data_n_index__tmp
-      ENDIF
-
       IF (PRESENT(data_ni_)) THEN
         data_ni__tmp = cxios_is_defined_domaingroup_data_ni(domaingroup_hdl%daddr)